﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;
using Sparkle.Effects.Renderer;
namespace Sparkle.Effects.TextEffects.Simple
{
	public class ExplodingTextEffect : TextEffectObject
	{
        Random Rnd;
        public float FadeInTime { set { base.TransateInDuration = value; } }
        private float Random;
        public ExplodingTextEffect(TextEffectRenderer renderer)
            : base(renderer)
        {
            Rnd = new Random();
            base.PlayEffectDuration = 4000;   
            
        }
        public override void InitializeEffect(string Text)
        {
            base.Initialize(Text,true);
            //throw new NotImplementedException();
            
        }

        internal override void PlayTransitionOnEffect(float percentElapsed, GameTime gt)
        {
            //throw new NotImplementedException();
            for (int i = 0; i < Objects.Count; i++)
                Objects[i].BlockColor = Objects[i].BlockOriginalColor * percentElapsed;
        }

        internal override void PlayEffect(float percentElapsed, GameTime gt)
        {

            for (int i = 0; i < Objects.Count; i++)
            {
                Objects[i].BlockOrigin = new Vector2(MathHelper.SmoothStep(0, Objects[i].BlockSize.X / 2, percentElapsed * 5),
                    MathHelper.SmoothStep(0, Objects[i].BlockSize.Y / 2, percentElapsed * 5));
           
                Objects[i].BlockRotation +=(1-percentElapsed)/Rnd.Next(i,Objects.Count+1);
                Objects[i].BlockPosition = new Vector2(
                    MathHelper.SmoothStep(Objects[i].PositionInWord_X,Objects[i].PositionInWord_X+ percentElapsed * 25, percentElapsed),
                    MathHelper.SmoothStep(0, percentElapsed * 25, percentElapsed));
            }
        }

        internal override void PlayTransitionOffEffect(float percentElapsed, GameTime gt)
        {
            //throw new NotImplementedException();
        }
    }
}
