﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;
using Sparkle.Effects.Renderer;
namespace Sparkle.Effects.TextEffects.Simple
{
    public class FadeInTextEffect : TextEffectObject
    {
        /// <summary>
        /// Duration of the effect to fade in
        /// </summary>
        public float FadeInTimer
        {
            set { PlayEffectDuration = value; }
        }
        
        ///// <summary>
        ///// Time for the effect to fade out.  -1 will keep the text visible at all time
        ///// </summary>
        //public float FadeOutTimer
        //{
        //    get { return _fadeOutTimer; }
        //    set { TransateOutDuration = value; _fadeOutTimer = value; }
        //}
        //private float _fadeOutTimer;

        /// <summary>
        /// Should the effect fade in by block or by the complete text
        /// </summary>
        public bool FadeInByBlock = false;
        public bool FadeOutByBlock = false;

        public FadeInTextEffect(TextEffectRenderer renderer)
            : base(renderer)
        {
            
        }
       
        /// <summary>
        /// Set up the effect with the provided Text
        /// </summary>
        /// <param name="Text">Text to display</param>
        public override void InitializeEffect(string Text)
        {
            base.Initialize(Text,true);
        }
        
        internal override void PlayTransitionOnEffect(float percentElapsed, GameTime gt)
        {

        }

        internal override void PlayEffect(float percentElapsed, GameTime gt)
        {
            if (FadeInByBlock)
            {
                if (BlockIndex < Objects.Count)
                {
                    Objects[BlockIndex].BlockColor = Objects[BlockIndex].BlockOriginalColor * percentElapsed;
                    if (percentElapsed >= 1)
                    {
                        BlockIndex++;
                        Elapsed_PlayEffectDuration = 0;
                    }
                }
            }
            else
            {
                for (int i = BlockIndex; i < Objects.Count; i++)
                    Objects[i].BlockColor = Objects[i].BlockOriginalColor * percentElapsed;
            }
        }

        internal override void PlayTransitionOffEffect(float percentElapsed, GameTime gt)
        {
            if (FadeOutTimer != -1)
                base.FadeOutEffect(percentElapsed, FadeOutByBlock);
        }

    }
}
