﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;
using Sparkle.Effects.Renderer;
namespace Sparkle.Effects.TextEffects.Simple
{
    public class SwirlTextEffect : TextEffectObject
    {
       //The radius of the swirl rotation
        public float Radius;
        
        //Number of rotations
        public int Rotations;
        
        //Initial scale of the text
        public float InitialScale;
        
        //Pause until the transition fades the effect
        public float PauseUntilFade
        { 
            set { PauseTime = value; } 
        }
       //Time in milliseconds to complete the in transition for the effect
        public float SwirlInTimer
        {
            set { PlayEffectDuration = value; }
        }
        public SwirlTextEffect(TextEffectRenderer renderer)
            : base(renderer)
        {
           
        }
        public override void InitializeEffect(string Text)
        {
            base.Initialize(Text, true);
            float anglus = 270;
            for (int i = 0; i < Objects.Count; i++)
            {

                Objects[i].BlockPosition = new Vector2(
                   (float)Math.Cos(anglus) * Radius,
                  (float)Math.Sin(anglus) * Radius);
                anglus += Objects[i].BlockSize.Y / Radius;
                Objects[i].BlockScale = InitialScale;
                Objects[i].BlockOrigin = new Vector2(Objects[i].BlockSize.X / 2, Objects[i].BlockSize.Y / 2);
            }
        }

        internal override void PlayTransitionOnEffect(float percentElapsed, GameTime gt)
        {
            //throw new NotImplementedException();
        }
        internal override void PlayEffect(float percentElapsed, GameTime gt)
        {
            for (int x = 0; x < Objects.Count; x++)
            {
                Objects[x].BlockColor = Objects[x].BlockOriginalColor * MathHelper.SmoothStep(0, 1, percentElapsed);
                float angle = ((360 * Rotations + (360 / Objects.Count) * x) * (float)Math.PI / 180) * percentElapsed;
                Objects[x].BlockScale =MathHelper.SmoothStep(InitialScale,1,  percentElapsed);
                Objects[x].BlockPosition = new Vector2(
                    MathHelper.SmoothStep((float)Math.Cos(angle) * Radius * (1 - percentElapsed), Objects[x].PositionInWord_X, percentElapsed),
                    MathHelper.SmoothStep((float)Math.Sin(angle) * Radius * (1 - percentElapsed), 0, percentElapsed));
                Objects[x].BlockOrigin = new Vector2(
                    MathHelper.SmoothStep(Objects[x].BlockSize.X / 2, 0, percentElapsed),
                    MathHelper.SmoothStep(Objects[x].BlockSize.Y / 2, 0, percentElapsed));
            }
        }
        internal override void PlayTransitionOffEffect(float percentElapsed, GameTime gt)
        {
            //base.FadeOutEffect(percentElapsed);
            for (int x = 0; x < Objects.Count; x++)
            {
                Objects[x].BlockColor = Objects[x].BlockOriginalColor * MathHelper.SmoothStep(1, 0, percentElapsed);
                float angle = ((360 * Rotations + (360 / Objects.Count) * x) * (float)Math.PI / 180) * (1-percentElapsed);
                Objects[x].BlockScale = MathHelper.SmoothStep(1, InitialScale, percentElapsed);
                Objects[x].BlockPosition = new Vector2(
                    MathHelper.SmoothStep(Objects[x].PositionInWord_X, (float)Math.Cos(angle) * Radius * (percentElapsed),percentElapsed),
                    MathHelper.SmoothStep(0,(float)Math.Sin(angle) * Radius * ( percentElapsed), percentElapsed));
                Objects[x].BlockOrigin = new Vector2(
                    MathHelper.SmoothStep(0,Objects[x].BlockSize.X / 2, percentElapsed),
                    MathHelper.SmoothStep(0,Objects[x].BlockSize.Y / 2, percentElapsed));
            }
        }
    }
}
